# Avoid Accident 101
___
 
## Description
___
Last year in Thailand there were a lot of accidents that are dangerous for everyone. My project is to create an app to find the best way to travel in thailand. My feature is to find the shortest path by using the dijkstra algorithm and app will show graph visualization.
* [`video`](https://youtu.be/8JqxH7XMYnI)
### Feature
* Find the shortest path
* Show graph visualization
* Show the number of accidents in each province
* Show the number of accidents in each province in each month
* Show the ratio of accidents in each type
### Start page
<img src="pic/start.png">

### Main page
<img src="pic/mainmenu.png" width="600" height="400">

### Find the shortest path
<img src="pic/mainmenu2.png">

### Map shortest path
<img src="pic/graph.png" width="600" height="400">


## Data Sources
___
* [`thailand_province_relations.txt`](code/thailand_province_relations.txt) relations data from [`github`](https://github.com/pmdscully/thailand_province_border_adjacency/blob/3a332ff3146a186981750e4710f1145d0dcbd627/thailand_province_relations.txt)
* [`province.json`](code/province.json) sample latitudes and longitudes from [`GPT`](https://openai.com/)
* [`accident2022(eng).csv`](file/accident2022(eng).csv) accident data from [`datagov`](https://datagov.mot.go.th/dataset/roadaccident/resource/733b7874-bd5f-44b9-b271-650890b061f2?inner_span=True)

## Running the Application
___
```commandline
pip install -r requirements.txt
```
if can't install basemap go to [`app.py`](code/app.py) and uncomment line 4 and comment line 5
<img src="pic/fix error.png">
 
## Design
___
### Class diagram
<img src="pic/UML classs.png" width="700" height="600">

### Sequence diagram
<img src="pic/sequence diagram.png" width="500" height="300">
 
## Design Patterns Used
Use [`facade`](https://refactoring.guru/design-patterns/facade) pattern to make the code more readable and easy to use.
App class is a facade class that will call other class to do the work.
 
## Graph Algorithm Used
[`Dijkstra algorithm`](https://en.wikipedia.org/wiki/Dijkstra%27s_algorithm) is used to find the shortest path between two nodes from Province s to Province t.
